/***************************************************************************
 *
 * knetworkmanager-device.h - A NetworkManager frontend for KDE 
 *
 * Copyright (C) 2005, 2006 Novell, Inc.
 *
 * Author: Timo Hoenig     <thoenig@suse.de>, <thoenig@nouse.net>
 *         Will Stephenson <wstephenson@suse.de>, <wstephenson@kde.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 **************************************************************************/

#ifndef KNETWORKMANAGER_WIRELESS_DEVICE_H
#define KNETWORKMANAGER_WIRELESS_DEVICE_H

#include "knetworkmanager.h"
#include "knetworkmanager-device.h"

#include <stdint.h>

#include <dbus/qdbusvariant.h>

class KNetworkManager;
class AccessPoint;
class WirelessDevicePrivate;

class WirelessDevice : public Device
{
	Q_OBJECT
	public:
		WirelessDevice (const QString & obj_path );
		~WirelessDevice ();

		Q_UINT32 getWirelessCapabilities() const;
		QValueList<AccessPoint*> accessPointsForEssid(QByteArray essid = QByteArray());
		QValueList<AccessPoint*> accessPoints();
		AccessPoint * getActiveAccessPoint();
		Q_UINT32 getBitrate() const;

	public slots:
		void slotPropertiesChanged(const QMap<QString, QDBusVariant>& properties);
		void slotAccessPointAdded(const QDBusObjectPath&);
		void slotAccessPointRemoved(const QDBusObjectPath&);

	signals:
		void propertiesChanged();
		void accessPointAdded(AccessPoint *);
		void accessPointRemoved(const QString &);

	private:
		void updateAPList();

		WirelessDevicePrivate * d;
};

#endif /* KNETWORKMANAGER_WIRELESS_DEVICE_H */
